#! /usr/local/bin/jperl
# *****************************************************************************
# *                                                                           *
# *  Copyright (C) JAPAN ELECTRONIC DICTIONARY RESEARCH INSTITUTE, LTD. 1997  *
# *                                                                           *
# *****************************************************************************
#
package subfunc ;

sub syukutai_jwd
{
    local( $word ) = @_ ;
    local( @str, @ret ) ;
    local( $ii, $wk ) ;

    @ret = () ;
    @str = split( "", $word ) ;
    if ( $#str == 0 ) {
        if ( $OomojiChar{ $str[0] } eq "") {
            return( $word ) ;
        }
        return( $OomojiChar{ $str[0] } ) ;
    }
    for( $ii = 0 ; $ii <= $#str ; $ii++ ) {
#        if ( $DelKanaChar{ $str[$ii] } == 1 ) {
#            next ;
#        }
        if ( $OomojiChar{ $str[$ii] } eq "") {
            push( @ret, $str[$ii] ) ;
        }
        else { 
            push( @ret, $wk ) ;
        }
    }
    $word = join( "", @ret ) ;
    return ( $word ) ;
}


sub syukutai_jwd2
{
    local( $word ) = @_ ;
    local( @str, @ret ) ;
    local( $ii, $wk ) ;

    @ret = () ;
    @str = split( "", $word ) ;
    if ( $#str == 0 ) {
        if ( $OomojiChar{ $str[0] } eq "") {
            return( $word ) ;
        }
        return( $OomojiChar{ $str[0] } ) ;
    }
    for( $ii = 0 ; $ii <= $#str ; $ii++ ) {
        if ( $DelKanaChar{ $str[$ii] } == 1 ) {
            next ;
        }
        if ( $DelHiraChar{ $str[$ii] } == 1 ) {
            next ;
        }
        if ( $OomojiChar{ $str[$ii] } eq "") {
            push( @ret, $str[$ii] ) ;
        }
        else { 
            push( @ret, $wk ) ;
        }
    }
    $word = join( "", @ret ) ;
    return ( $word ) ;
}



sub syukutai_yomi
{
    local( $word ) = @_ ;
    local( @str, @ret ) ;
    local( $word_x ) ;

    @ret = () ;
    @str = split( "", $word ) ;
    if ( $#str == 0 ) {
        return( $word ) ;
    }
    $word_x = &mur_Change_yomi( $word ) ;
    #if ( $word ne $word_x ) {
    #    print STDERR "==========[$word]====>[$word_x]\n" ;
    #}
    return ( $word_x ) ;
}


sub mur_Change_yomi
{
    local( $_ ) = @_ ;
    s/ȥ//g;
    s/ɥ//g;
    s/ե//g;
    s/ե//g;
    s/ե//g;
    s/ե//g;
    s/ե//g;
    s/ե//g;
    s/ե//g;
    s/ե//g;
    s///g;
    s///g;
    s///g;
    s///g;
    s///g;
    s/ƥ//g;
    s/ĥ//g;
    s/ǥ//g;
    s///g;
    s///g;
    s///g;
    s///g;
    s///g;
    s///g;
    s///g;
    s///g;
    s///g;
    s///g;
    s///g;
    s///g;
    s///g;
    s///g;
    s///g;
    s/ƥ//g;
    s/ǥ//g;
    s/ե/ҥ/g;
    s//ӥ/g;
    s///g;
    s///g;
    s///g;
    s///g;
    s///g;
    s/塼//g;
    s/([ƥͥإ쥲ǥ٥])/$1/g;
    s/([ȥΥۥ祴ɥܥ])/$1/g;
    s/([ʥϥޥ㥬Х])/$1/g;
    s/([˥ҥߥꥮ¥ӥ])/$1/g;
    s/([ĥ̥ե奰ť֥])/$1/g;
    s/([ƥͥإ쥲ǥ٥])/$1/g;
    s/([ȥΥۥ祴ɥܥ])/$1/g;

    s/([˥ҥߥꥮ¥ӥ])/$1/g;
    s/([˥ҥߥꥮ¥ӥ])/$1/g;
    s/([ƥͥإ쥲ǥ٥])/$1/g;
    s/([ƥͥإ쥲ǥ٥])/$1/g;

    s///g;
    s///g;
    s///g;
    s///g;
    return( $_ ) ;
}


sub allkana
{
    local( $word ) = @_ ;
    local( @str ) ;
    local( $ii ) ;

    @str = split( "", $word ) ;
    for( $ii = 0 ; $ii <= $#str ; $ii++ ) {
        if ( $KanaChar{ $str[$ii] } eq "" ) {
            return( 0 ) ;
        }
    }
    return ( 1 ) ;
}


%DelHiraChar = (
	'', '',
	'', '',
	'', '',
	'', '',
	'', '',
	'', '',
	'', '',
	'', '',
	'', '',
	'', '',
	'', '',
	'', '',
	'', '',
	'', '',
	'', '',
	'', '',
	'', '',
	'', '',
	'', '',
	'', '',
	'', '',
	'', '',
	'', '',
	'', '',
	'', '',
	'', '',
	'', '',
	'', '',
	'', '',
	'', '',
	'', '',
	'', '',
	'', '',
	'', '',
	'', '',
	'', '',
	'', '',
	'', '',
	'', '',
	'', '',
	'', '',
	'', '',
	'', '',
	'', '',
	'', '',
	'', '',
	'', '',
	'', '',
	'', '',
	'', '',
	'', '',
	'', '',
	'', '',
	'', '',
	'', '',
	'', '',
	'', '',
	'', '',
	'', '',
	'', '',
	'', '',
	'', '',
	'', '',
	'', '',
	'', '',
	'', '',
	'', '',
	'', '',
	'', '',
	'', '',
	'', '',
	'', '',
	'', '',
	'', '',
	'', '',
	'', '',
	'', '',
	'', '',
	'', '',
	'', '',
	) ;

%DelKanaChar = (
        '', 1,
        '', 1,
        '', 1,
        '', 1,
        '', 1,
        '', 1,
        '', 1,
        '', 1,
        '', 1,
        '', 1,
        '', 1,
        '', 1,
        '', 1,
        '', 1,
        '', 1,
        '', 1,
        '', 1,
        '', 1,
        '', 1,
        '', 1,
        '', 1,
        '', 1,
        '', 1,
        '', 1,
        '', 1,
        '', 1,
        '', 1,
        '', 1,
        '', 1,
        '', 1,
        '', 1,
        '', 1,
        '', 1,
        '', 1,
        '', 1,
        '', 1,
        '', 1,
        '', 1,
        '', 1,
        '', 1,
        '', 1,
        '', 1,
        '', 1,
        '', 1,
        '', 1,
        '', 1,
        '', 1,
        '', 1,
        '', 1,
        '', 1,
        '', 1,
        '', 1,
        '', 1,
        '', 1,
        '', 1,
        '', 1,
        '', 1,
        '', 1,
        '', 1,
        '', 1,
        '', 1,
        '', 1,
        '', 1,
        '', 1,
        '', 1,
        '', 1,
        '', 1,
        '', 1,
        '', 1,
        '', 1,
        '', 1,
        '', 1,
        '', 1,
        '', 1,
        '', 1,
        '', 1,
        '', 1,
        '', 1,
        '', 1,
        '', 1,
        '', 1,
        '', 1,
        '', 1,
        '', 1,
        '', 1,
        '', 1,
        '', 1,
        '', 1,
        '-', 1,
        '/', 1,
        '\"', 1
	) ;


%komojiChar = (
       'A', 'a',
       'B', 'b',
       'C', 'c',
       'D', 'd',
       'E', 'e',
       'F', 'f',
       'G', 'g',
       'H', 'h',
       'I', 'i',
       'J', 'j',
       'K', 'k',
       'L', 'l',
       'M', 'm',
       'N', 'n',
       'O', 'o',
       'P', 'p',
       'Q', 'q',
       'R', 'r',
       'S', 's',
       'T', 't',
       'U', 'u',
       'V', 'v',
       'W', 'w',
       'X', 'x',
       'Y', 'y',
       'Z', 'z'
       ) ;

%OomojiChar = (
       'a', 'A',
       'b', 'B',
       'c', 'C',
       'd', 'D',
       'e', 'E',
       'f', 'F',
       'g', 'G',
       'h', 'H',
       'i', 'I',
       'j', 'J',
       'k', 'K',
       'l', 'L',
       'm', 'M',
       'n', 'N',
       'o', 'O',
       'p', 'P',
       'q', 'Q',
       'r', 'R',
       's', 'S',
       't', 'T',
       'u', 'U',
       'v', 'V',
       'w', 'W',
       'x', 'X',
       'y', 'Y',
       'z', 'Z'
       ) ;

%KanaChar = (
        '', 1,
        '', 1,
        '', 1,
        '', 1,
        '', 1,
        '', 1,
        '', 1,
        '', 1,
        '', 1,
        '', 1,
        '', 1,
        '', 1,
        '', 1,
        '', 1,
        '', 1,
        '', 1,
        '', 1,
        '', 1,
        '', 1,
        '', 1,
        '', 1,
        '', 1,
        '', 1,
        '', 1,
        '', 1,
        '', 1,
        '', 1,
        '', 1,
        '', 1,
        '', 1,
        '', 1,
        '', 1,
        '', 1,
        '', 1,
        '', 1,
        '', 1,
        '', 1,
        '', 1,
        '', 1,
        '', 1,
        '', 1,
        '', 1,
        '', 1,
        '', 1,
        '', 1,
        '', 1,
        '', 1,
        '', 1,
        '', 1,
        '', 1,
        '', 1,
        '', 1,
        '', 1,
        '', 1,
        '', 1,
        '', 1,
        '', 1,
        '', 1,
        '', 1,
        '', 1,
        '', 1,
        '', 1,
        '', 1,
        '', 1,
        '', 1,
        '', 1,
        '', 1,
        '', 1,
        '', 1,
        '', 1,
        '', 1,
        '', 1,
        '', 1,
        '', 1,
        '', 1,
        '', 1,
        '', 1,
        '', 1,
        '', 1,
        '', 1,
        '', 1,
        '', 1
       ) ;



1;
